' Description: A simple VB Script sample of using the GPC COM library.
'              In this sample we will load two polygon difinition files
'              from the local C drive and intersect them.
'
'
' Author: Tom Wolf (tom@www.aftershock.co.il)
' =======================================================================

'declare consts
Const clipDifference 	= 0
Const clipIntersection 	= 1
Const clipXOR 		= 2
Const clipUnion 	= 3

Call Main

Sub Main()
	Dim pPolygonSubject 	'Declare subject polygon (will hold england)
	Dim pPolygonClip 	'Declare clip polygon (will hold arrows)
	Dim pPolygonRet 	'Declare intersection returned polygon

	'Create subject polygon
	Set pPolygonSubject = CreateObject("GPCCOM.GPC_Polygon")

	'Test creation
	If pPolygonSubject Is Nothing Then
		MsgBox "Unable to create GPC_Polygon object!", vbExclamation
		Exit Sub
	End If

	'Create clip polygon
	Set pPolygonClip = CreateObject("GPCCOM.GPC_Polygon")
	
	'Test creation
	If pPolygonClip Is Nothing Then
		MsgBox "Unable to create GPC_Polygon object!", vbExclamation
		Exit Sub
	End If

	
	'try loading the "england" polygon
	If pPolygonSubject.Load("c:\england.gpf") Then
		
		'try loading the "arrows" polygon
		If pPolygonClip.Load("c:\arrows.gpf") Then
			Dim nStart, nEnd 'use to calculate performance

			nStart = Timer
			Set pPolygonRet = pPolygonSubject.Clip(clipIntersection, pPolygonClip)
			nEnd = Timer - nStart

			If Not pPolygonRet Is Nothing Then
				
				'write polygon to local disk				
				pPolygonRet.Save "c:\ret.gpf"

				MsgBox "Successfully intersected polygons in: " & CStr(nEnd) & " seconds!", vbInformation
				
				'free result polygon
				Set pPolygonRet = Nothing
			Else
				MsgBox "Failed to clip polygons!", vbExclamation
			End If
		Else
			MsgBox "Unable to load Arrows polygon!", vbExclamation
		End If

	Else
		MsgBox "Unable to load England polygon!", vbExclamation
	End If
	

	'free subject polygon
	Set pPolygonSubject = Nothing

	'free clip polygon
	Set pPolygonClip = Nothing
End Sub

