VERSION 5.00
Begin VB.Form frmMain 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   Caption         =   "GPC COM VB Graph Sample"
   ClientHeight    =   6240
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7695
   LinkTopic       =   "Form1"
   ScaleHeight     =   6240
   ScaleWidth      =   7695
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuOpt 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptLoad 
         Caption         =   "Load Polygons"
      End
      Begin VB.Menu mnuOptSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOptShowSubject 
         Caption         =   "Show Subject"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuOptShowClip 
         Caption         =   "Show Clip"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuOptShowClipResult 
         Caption         =   "Show Clip Result"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuOptSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOptDif 
         Caption         =   "Diff"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuOptInt 
         Caption         =   "Intersect"
      End
      Begin VB.Menu mnuOptXOR 
         Caption         =   "XOR"
      End
      Begin VB.Menu mnuOptUnion 
         Caption         =   "Union"
      End
   End
   Begin VB.Menu mnuAbt 
      Caption         =   "&About"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Description: This sample shows how simple it is to work with the GPC
'              COM interfaces when you want to manipulate polygons.
'              The sample loads a subject and clip polygons and draws
'              them on screen
'
' Author: Tom Wolf (tom@www.aftershock.co.il)
' =======================================================================
Option Explicit

Private Type RECT
    Left As Double
    Top As Double
    Right As Double
    Bottom As Double
End Type

Dim g_pPolygonSubject As GPC_Polygon
Dim g_pPolygonClip As GPC_Polygon

Dim g_minmaxRect As RECT
Function GetClipType() As ClipOption
    If mnuOptDif.Checked = True Then
        GetClipType = clipDifference
    ElseIf mnuOptInt.Checked = True Then
        GetClipType = clipIntersection
    ElseIf mnuOptXOR.Checked = True Then
        GetClipType = clipXOR
    ElseIf mnuOptUnion.Checked = True Then
        GetClipType = clipUnion
    End If
End Function
Sub TestMinMaxOnVertex(ByVal pVertex As IGPC_Vertex)
    
    If pVertex.X < g_minmaxRect.Left Then g_minmaxRect.Left = pVertex.X
    If pVertex.X > g_minmaxRect.Right Then g_minmaxRect.Right = pVertex.X
    
    If pVertex.Y < g_minmaxRect.Bottom Then g_minmaxRect.Bottom = pVertex.Y
    If pVertex.Y > g_minmaxRect.Top Then g_minmaxRect.Top = pVertex.Y

End Sub
Function CalcMinMax() As Boolean
    If Not g_pPolygonSubject Is Nothing And Not g_pPolygonClip Is Nothing Then
        
        'test to see if we have valid polygons
        If g_pPolygonSubject.Contours.Count > 0 And g_pPolygonClip.Contours.Count > 0 Then
            Dim bFirst As Boolean
            bFirst = True
            
            Dim pContour As IGPC_VertexList
            Dim pVertex As IGPC_Vertex
            
            'find subjects min max
            'we will iterate of each contour and over each vertex in each contour
            For Each pContour In g_pPolygonSubject.Contours
                For Each pVertex In pContour
                    
                    'test to see if first iteration
                    If bFirst Then
                        bFirst = False 'change flag
                        
                        'init rect
                        g_minmaxRect.Left = pVertex.X 'minX
                        g_minmaxRect.Bottom = pVertex.Y 'minY
                        g_minmaxRect.Right = pVertex.X 'maxX
                        g_minmaxRect.Top = pVertex.Y 'maxY
                    Else
                        'do test
                        TestMinMaxOnVertex pVertex
                    End If
                Next
            Next
            
            'find clips min max
            For Each pContour In g_pPolygonClip.Contours
                For Each pVertex In pContour
                    TestMinMaxOnVertex pVertex
                Next
            Next
            
            CalcMinMax = True
            Exit Function
        End If
        
    End If
    
    CalcMinMax = False
End Function
Sub DrawPolygon(ByVal pPolygon As GPC_Polygon, ByVal nColor As Long, ByVal nPenWidth As Integer)
    DrawWidth = nPenWidth
        
    Dim pContour As IGPC_VertexList
    Dim pVertex As IGPC_Vertex
    
    For Each pContour In pPolygon.Contours
        If pContour.Count > 2 Then 'for safety
            Dim i As Integer
            'because we need previous coordinates we will iterate using an index
            For i = 1 To pContour.Count - 1 'zero based
                Line (pContour.Item(i - 1).X, pContour.Item(i - 1).Y)-(pContour.Item(i).X, pContour.Item(i).Y), nColor
            Next i
            
            'connect last and first coordinates to form a polygon
            Dim nLastItem As Integer
            nLastItem = pContour.Count - 1
            Line (pContour.Item(nLastItem).X, pContour.Item(nLastItem).Y)-(pContour.Item(0).X, pContour.Item(0).Y), nColor
        End If
    Next
End Sub

Sub Draw()
    Cls 'clear graph
    
    'set scalemode
    'remember that our graphs origin is the upper left corner, in order to fix this
    'we will set the scale boundrys ymin as our ymax and vice versa
    'in order to capture our polygons, we will increase the size of our rect by one
    'in each side.
    Scale (g_minmaxRect.Left - 1, g_minmaxRect.Top + 1)-(g_minmaxRect.Right + 1, g_minmaxRect.Bottom - 1)
    
    If Not g_pPolygonSubject Is Nothing And Not g_pPolygonClip Is Nothing Then
        
        If g_pPolygonSubject.Contours.Count > 0 And g_pPolygonClip.Contours.Count > 0 Then
            'create clip result polygon
            Dim pPolygonClipResult As New GPC_Polygon
            
            'clip our polygons
            Set pPolygonClipResult = g_pPolygonSubject.Clip(GetClipType, g_pPolygonClip)
            
            If Not pPolygonClipResult Is Nothing Then
                If mnuOptShowSubject.Checked Then DrawPolygon g_pPolygonSubject, vbBlue, 1 'draw subject
                If mnuOptShowClip.Checked Then DrawPolygon g_pPolygonClip, vbBlue, 1 'draw clip
                If mnuOptShowClipResult.Checked Then DrawPolygon pPolygonClipResult, vbRed, 2  'draw clip result
                
                Set pPolygonClipResult = Nothing 'free polygon
            End If
        End If
        
    End If
    
End Sub

Private Sub Form_Load()
    'initialize
    g_minmaxRect.Left = 0
    g_minmaxRect.Bottom = 0
    g_minmaxRect.Right = 0
    g_minmaxRect.Top = 0
End Sub

Private Sub Form_Resize()
    'draw our graph on resize
    Draw
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'free polygons
    Set g_pPolygonSubject = Nothing
    Set g_pPolygonClip = Nothing
End Sub

Private Sub mnuAbt_Click()
    MsgBox "GPC COM Graph Sample" & vbNewLine & vbNewLine & "Programmed by: Tom Wolf (tom@www.aftershock.co.il)" & vbNewLine & "Based on the great ""GPC"" library by: Alan Murta (gpc@cs.man.ac.uk)" & vbNewLine & vbNewLine & "Remember to visit: http://www.cs.man.ac.uk/aig/staff/alan/software/", vbInformation, "About"
End Sub

Private Sub mnuOptDif_Click()
    mnuOptDif.Checked = True
    mnuOptInt.Checked = False
    mnuOptXOR.Checked = False
    mnuOptUnion.Checked = False
    
    Draw
End Sub

Private Sub mnuOptInt_Click()
    mnuOptDif.Checked = False
    mnuOptInt.Checked = True
    mnuOptXOR.Checked = False
    mnuOptUnion.Checked = False
    
    Draw

End Sub

Private Sub mnuOptLoad_Click()
    'free polygons
    Set g_pPolygonSubject = Nothing
    Set g_pPolygonClip = Nothing
    
    'create polygons
    Set g_pPolygonSubject = New GPC_Polygon
    Set g_pPolygonClip = New GPC_Polygon
    
    Dim strFile As String
    
    'ask for file
    strFile = InputBox("Enter subject polygon file", "Subject", "c:\england.gpf")
    
    If strFile = "" Then Exit Sub
    
    If Dir$(strFile) = "" Then
        MsgBox "The file: " & strFile & " doesn't exist!", vbExclamation, "Error"
        Exit Sub
    End If

    'try loading polygon
    If Not g_pPolygonSubject.Load(strFile) Then
        MsgBox "Unable to load subject polygon!", vbExclamation
        Set g_pPolygonSubject = Nothing
        Set g_pPolygonClip = Nothing
    End If
    
    'ask for file
    strFile = InputBox("Enter clip polygon file", "Clip", "c:\arrows.gpf")
    
    If strFile = "" Then Exit Sub
    
    If Dir$(strFile) = "" Then
        MsgBox "The file: " & strFile & " doesn't exist!", vbExclamation, "Error"
        Exit Sub
    End If

    'try loading polygon
    If Not g_pPolygonClip.Load(strFile) Then
        MsgBox "Unable to load clip polygon!", vbExclamation
        Set g_pPolygonSubject = Nothing
        Set g_pPolygonClip = Nothing
    End If
    
    'calculate min and max coordinates so that we can set graph scale
    CalcMinMax
       
    'draw
    Draw
End Sub

Private Sub mnuOptShowClip_Click()
    mnuOptShowClip.Checked = Not mnuOptShowClip.Checked
    
    Draw

End Sub

Private Sub mnuOptShowClipResult_Click()
    mnuOptShowClipResult.Checked = Not mnuOptShowClipResult.Checked
    
    Draw
End Sub

Private Sub mnuOptShowSubject_Click()
    mnuOptShowSubject.Checked = Not mnuOptShowSubject.Checked
    
    Draw
End Sub

Private Sub mnuOptUnion_Click()
    mnuOptDif.Checked = False
    mnuOptInt.Checked = False
    mnuOptXOR.Checked = False
    mnuOptUnion.Checked = True
    
    Draw
End Sub

Private Sub mnuOptXOR_Click()
    mnuOptDif.Checked = False
    mnuOptInt.Checked = False
    mnuOptXOR.Checked = True
    mnuOptUnion.Checked = False
    
    Draw
End Sub
